var request = require('request')
process.env.NODE_TLS_REJECT_UNAUTHORIZED = "0";
var host = null;
var hypervisorvm_path = require('./config').hypervisorvm_path
var ngp = require('../../ecxngp');
const json2csv = require('json2csv').parse;
var storage_path = require('./config').storage_path
var applicationdatabase_path = require('./config').applicationdatabase_path
var setSessionandHeader = require('./helpfunction').setSessionandHeader
var option = {
    method:'GET',
    url:'',
    headers:
        {
            'x-endeavour-sessionid':'',
            'x-endeavour-auditrequest':'yes',
            'Content-Type':'application/json',
            'Accept':'application/json'
        },
}

function getstorageName( starturl , resolve , reject)
{
    option.url = starturl
    var storagename = {}
    function loop ()
    {
        request( option , function(error , response , body ){
            if(!error && response.statusCode == 200 )
            {
                var storages = JSON.parse(body).storages
                var links = JSON.parse(body).links
                for( var i in storages )
                {
                    storagename[ storages[i].storageId ] = storages[i].name
                }
                if('nextPage' in links)
                {
                    option.url = links.nextPage.href
                    return loop()
                }
                else
                {            

                    return resolve(storagename)
                }
            }
            else
            {
                console.error(error)
                const err = new Error("Error while getting storage names")
                err.status = 403
                return reject(err);
            }

        })
    }
    return loop()
}
function getBackupdetail( starturl, resolve, reject ,storagename)
{
	var vminfo_list = []
	option.url = starturl
	function loop ()
	{
		request( option , function( error, response, body ) 
		{
			if(!error && response.statusCode == 200 )
			{
				var vmlists = JSON.parse(body).children
				var links = JSON.parse(body).links
				for( var index in vmlists )
				{
					var vminfo = {}
					var vm = vmlists[index]
					vminfo['VMs'] = vm.name
                    vminfo['SLAPolicy'] = vm.properties.protectionInfo.storageProfileName
                    vminfo['Hypervisor'] = vm.properties.hypervisorHostName
                    vminfo['ProtectionTime'] = vm.properties.protectionInfo.protectionTime
                    vminfo['ProtectionMethod'] = vm.properties.protectionInfo.storageSnapshots[0].storageType
                    vminfo['BackupStorage'] = storagename[vm.properties.protectionInfo.storageSnapshots[0].storageId]
                    vminfo['BackupSize'] = vm.properties.protectionInfo.transferSize / Math.pow(10,6)
                    vminfo['BackupSpeed'] = vminfo['BackupSize'] / vm.properties.protectionInfo.transferDuration
					vminfo_list.push(vminfo)
				}
				if('nextPage' in links)
                {
                    option.url = links.nextPage.href
                    return loop()
                }
                else
                {
                    return resolve(vminfo_list)
                }
			}
			else
            {
                console.error(error)
                const err = new Error("Error while getting backup records")
                err.status = 403
                return reject(err);
            }
		})
	}
	return loop();
}
function data2Response( vminfo_list , res ,req)
{
    if('download' in req.query && req.query['download'] == 'true')
    {
        if('type' in req.query && req.query['type'] == 'csv')
        {
            res.setHeader('Content-Disposition', 'attachment;filename = "billreport.csv"')
            if(vminfo_list.length == 0)
            {
                const fields = ['VMs', 'SLAPolicy', 'Hypervisor','ProtectionTime','ProtectionMethod','BackupStorage','BackupSize','BackupSpeed'];
                const opts = { fields };    
                var csv = json2csv(vminfo_list,opts);
                res.write(csv)
                res.end()                       
            }
            else
            {
                var csv = json2csv(vminfo_list);
                res.write(csv)
                res.end()   
            }

        }
        else
        {
            res.setHeader('Content-Disposition', 'attachment')
            res.json(vminfo_list)
        }
    }
    else
    {
        res.json(vminfo_list)
    }
}

function getBillinfo( res, req, next, isvm )
{
    setSessionandHeader(res,req,host)
    .then(function(value){
        option.headers['x-endeavour-sessionid'] = value[0]
        host = value[1]
    })
    .then(function()
    {
        return new Promise( function(resolve, reject){
            getstorageName(host+storage_path,resolve,reject);
        })
    })
    .then(function(storagename){
        return new Promise( function(resolve, reject)
        {
            if( isvm )  getBackupdetail(host+hypervisorvm_path,resolve,reject,storagename );
            else getBackupdetail(host+applicationdatabase_path,resolve,reject,storagename);
        })
    })
    .then(function(vminfo_list){
        data2Response( vminfo_list ,res, req)
    })
    .catch(function(error){
        console.log(error)
        next(error)
    })
}

module.exports = 
{
    getBillinfo : getBillinfo
}