if (!('contains' in String.prototype)) {
	  String.prototype.contains = function(str, startIndex) {
	    return ''.indexOf.call(this, str, startIndex) !== -1;
	  };
	}

if (typeof String.prototype.startsWith != 'function') {
    String.prototype.startsWith = function(prefix) {
        return this.slice(0, prefix.length) == prefix;
    };
}
		 
if (typeof String.prototype.endsWith != 'function') {
    String.prototype.endsWith = function(suffix) {
        return this.slice(-suffix.length) == suffix;
    };
}


var ngp = require('./ecxngp');   


var funcSteps = [                                                                                    // generalized user handling + provider registration
	{                                                                                                // NB: nothing in this block will change
		continue: 'next',                                                                            // first constituent always continues
		name: 'stp_test',
		verb: 'POST',
		path: '/api/endeavour/trigger',
		ip: null,                                                                                                                                        
		port: null, 
		type: null,
		cb: function(res, data){ ngp.logMsg('info', 'Step=' + this.name + ' finished');}
	}, 	
];


const stepTestFuncs = {
	stp_test: function(step, funcStream, ecxSessionId, oFromNg, cb){          
		testTheStep(step, funcStream, ecxSessionId, oFromNg, cb);      	                     
    },	
};


exports.init = init;


function init(req, res, providerType)                                    
{
	var ngState = ngp.getSessionState(req, res);

	if ( ngState.stale )                                                                             // FTI we got bounced while client remained up. AND response already sent.
		return;                                                                                      // !!! R U CERTAIN THAT RESPONSE SENT IN ALL CASES HERE?

	var ecxSid = ngState.ecxSid;
	res.ecxSid = ecxSid;

	var stepsStream = JSON.parse(JSON.stringify(funcSteps));                                    

	stepsStream.forEach(function(step){
		step.ip = ngp.localIp;
		step.port = ngp.ecxExternal;

		step.func = stepTestFuncs[step.name];                                                  // hook up the step's real workhorse

		step.cb = function(ecxSid, data){ 
			ngp.logMsg('info', "Finished step '" + ngState.currentFunc + '(' + this.name + ")' in session ID '" + ecxSid + "'");

			if ( data )
			{
				ngp.logMsg('debug', "Data returned by step '" + ngState.currentFunc + '(' + this.name + ")' in session ID '" + ecxSid + "'=" + JSON.stringify(data));
			}
		};
	});

	ngState.currentFunc = 'test_' + 'thestep';                                 
	return stepsStream;
}


function testTheStep(step, funcStream, ecxSessionId, oFromNg, cb)
{
	var crSummaryResults = ngp.getEndpointState(ecxSessionId, 'policiesCreationResults');    // push to next step in case needed (successful) !!hypp

	var successResult = {
		statusCode: 200,
		response: {testing: '1, 2, 3'},    
	};
	
	var o = {
		jive: 1,
		opProperties: {
			barf: 2,
			xveServerInfo: {

			},
		},
	};

	ngp.setStepSuccessResult(step, funcStream, ecxSessionId, oFromNg, cb, successResult);	
}
